Attribute VB_Name = "modMSVBVM60"
Option Explicit

' 2   src  dest.  0.
Public Declare Function GetMem2 Lib "msvbvm60" (ByVal ptrToIntSrc As Long, ByVal ptrToIntDest As Long) As Long

' 4   src  dest.  0.
Public Declare Function GetMem4 Lib "msvbvm60" (ByVal ptrToLongSrc As Long, ByVal ptrToLongDest As Long) As Long

' 8   src  dest.  0.
Public Declare Function GetMem8 Lib "msvbvm60" (ByVal ptrToDDWORDSrc As Long, ByVal ptrToDDWORDDest As Long) As Long


' 2   dest.  0.
'   LOWORD  .
Public Declare Function PutMem2 Lib "msvbvm60" (ByVal ptrToIntDest As Long, ByVal NewValue As Long) As Long

' 4   dest.  0.
Public Declare Function PutMem4 Lib "msvbvm60" (ByVal ptrToLongDest As Long, ByVal NewValue As Long) As Long

' 8   dest.  0.
Public Declare Function PutMem8 Lib "msvbvm60" (ByVal ptrToQWORDDest As Long, ByVal NewValueLowDWORD As Long, ByVal NewValueHighDWORD As Long) As Long

' SAFEARRAY**
',  VarPtr.   ,     .
'  SAFEARRAY*,   GetMem4   SAFEARRAY**.
Public Declare Function ArrPtr Lib "msvbvm60" Alias "VarPtr" (arr() As Any) As Long


Private Declare Sub SafeArrayAllocDescriptor Lib "oleaut32.dll" (ByVal cDims As Long, ppsaOut As Any)
Private Declare Sub SafeArrayDestroyDescriptor Lib "oleaut32.dll" (psa As Any)

Public Function CreateSAFEARRAY(ByVal ppBlankArr As Long, ByVal ElemSize As Long, ByVal pData As Long, ParamArray Bounds()) As Long
  Dim p As Long, i As Long
  
  'ParamArray Bounds -    :
  'bounds(0) -    
  'bounds(1) -    
  'bounds(2) -    
  'bounds(3) -      ..
  
  SafeArrayAllocDescriptor (UBound(Bounds) + 1) / 2, ByVal ppBlankArr
  
  GetMem4 ppBlankArr, VarPtr(p)
  PutMem4 p + 4, ElemSize
  PutMem4 p + 12, pData
  
  For i = 0 To UBound(Bounds) Step 2
    PutMem4 p + 16 + i * 4, Bounds(i + 1) - Bounds(i) + 1
    PutMem4 p + 20 + i * 4, Bounds(i)
  Next
End Function

Public Function DestroySAFEARRAY(ByVal ppArray As Long) As Long
  Dim p As Long
  
  GetMem4 ppArray, VarPtr(p)
  SafeArrayDestroyDescriptor ByVal p
  PutMem4 ppArray, 0
End Function

Public Function ArrayExists(arr() As Long) As Long
  GetMem4 ArrPtr(arr), VarPtr(ArrayExists)
End Function
